<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8" />
    <title>Category API</title>

    <link rel="stylesheet" href="/css/bootstrap.min.css">

</head>

<body class="bg-light">
    <nav class="navbar navbar-expand-lg navbar-light bg-white border-bottom">
        <a class="navbar-brand" href="#">Point of Sale</a>
    </nav>
    <div class="container-fluid">
        <div class="row" style="min-height: 93.8vh">
            <div class="col-md-2 bg-white shadow">
                <div class="list-group mt-3">
                    <a href="/category/index" class="list-group-item list-group-item-action active">Category</a>
                    <a href="/variant/index" class="list-group-item list-group-item-action ">Variant</a>
                    <a href="/product/index" class="list-group-item list-group-item-action ">Product</a>
                    <a href="/orderheader/index" class="list-group-item list-group-item-action">Order header</a>
                    <a href="/orderdetail/index" class="list-group-item list-group-item-action">Order detail</a>
                </div>
            </div>
            <div class="col-md-10">
                <div class="card mt-3">
                    <div class="card-body shadow">
                        <h2>Category API</h2>
                        <p>
                            <button class="btn btn-primary" onclick="OpenList(0, 5)">Open List</button>
                            <button class="btn btn-primary" onclick="OpenForm()">Open Add Form</button>
                        </p>
                        <input class="form-control" type="text" placeholder="Search" onkeyup="SearchCategory(this.value)" autocomplete="off">
                        <div id="categoryList"></div>
                    </div>
                </div>
            </div>
        </div>
    </div>

    <script src="/js/jquery-3.5.1.min.js"></script>
    <script src="/js/bootstrap-bundle.min.js"></script>

    <script>
        function OpenList(currentPage, length) {
            $.ajax({
                url: '/api/categorymapped?page=' + currentPage + '&size=' + length,
                type: 'GET',
                contentType: 'application/json',
                success: function(data) {

                    let table = '<select class="custom-select mt-3" id="size" onchange="OpenList(0,this.value)">'
                    table += '<option value="3" selected>..</option>'
                    table += '<option value="5">5</option>'
                    table += '<option value="10">10</option>'
                    table += '<option value="15">15</option>'
                    table += '</select>'
                    table += "<table class='table table-hover'>";
                    table += "<tr> <th width='10%' class='text-center'>#</th> <th>Category Code</th> <th>Name</th> <th>Action</th> </tr>"
                    for (let i = 0; i < data.category.length; i++) {
                        table += "<tr>";
                        table += "<td class='text-center'>" + ((i + 1) + (data.currentPage * length)) + "</td>";
                        table += "<td>" + data.category[i].categoryCode + "</td>";
                        table += "<td>" + data.category[i].categoryName
                        table += "<td><button class='btn btn-primary btn-sm' value='" + data.category[i].id + "' onclick=FormEdit(this.value)>Edit</button> <button class='btn btn-danger btn-sm' value='" + data.category[i].id + "' onclick=DeleteCategory(this.value)>Delete</button></td>";
                        // table += "<td><input type='checkbox' onclick='SelectedItem()' class='mychecked' id='listdelete' value='"+data.category[i].id+"'></td>"
                        table += "</tr>";
                    }
                    table += "</table>";
                    table += "<br>"
                    table += '<nav aria-label="Page navigation">';
                    table += '<ul class="pagination">'
                    table += '<li class="page-item"><a class="page-link" onclick="OpenList(' + (data.currentPage - 1) + ',' + length + ')">Previous</a></li>'
                    let index = 1;
                    for (let i = 0; i < data.totalPages; i++) {
                        table += '<li class="page-item"><a id="pageslink" class="page-link" onclick="OpenList(' + i + ',' + length + ')">' + index + '</a></li>'
                        index++;
                    }
                    table += '<li class="page-item"><a class="page-link" onclick="OpenList(' + (data.currentPage + 1) + ',' + length + ')">Next</a></li>'
                    table += '</ul>'
                    table += '</nav>';
                    $('#categoryList').html(table);
                }
            });
        }



        function OpenForm() {
            var form = '<table class="table table-bordered"';
            form += "<tr>";
            form += "<td>Category Code</td>";
            form += '<td><input class="form-control" type ="text" id="category_code"></td>';
            form += "</tr>";
            form += "<tr>";
            form += "<td>Category Name</td>";
            form += '<td><input class="form-control" type ="text" id="category_name"></td>';
            form += "</tr>";
            form += "<tr>";
            form += '<td colspan="2"><button class="btn btn-primary" onclick = "SaveCategory(this.value)">Save</button></td>';
            form += '</tr>';
            $("#categoryList").html(form);
        }

        function SaveCategory() {
            var formData = '{';
            formData += '"categoryCode":"' + $('#category_code').val() + '",';
            formData += '"categoryName":"' + $('#category_name').val() + '"';
            formData += '}';

            $.ajax({
                url: '/api/category',
                type: 'post',
                contentType: 'application/json',
                data: formData,
                success: function(data) {
                    OpenList(0, 5);
                }
            });
        }

        function formEdit(id) {
            $.ajax({
                url: '/api/category/' + id,
                type: 'get',
                contentType: 'application/json',
                success: function(data) {
                    var form = '<table class="table table-bordered">';
                    form += "<tr>";
                    form += "<td>Category Code</td>";
                    form += '<td><input class="form-control" type ="text" id="category_code" value="' + data.categoryCode + '"><input class="form-control" type="hidden" id="created_by" value="' + data.createdBy + '"></td>';
                    form += "</tr>";
                    form += "<tr>";
                    form += "<td>Category Name</td>";
                    form += '<td><input class="form-control" type="text" id="category_name" value="' + data.categoryName + '"><input class="form-control" type="hidden" id="created_on" value="' + data.createdOn + '"></td>';

                    form += "</tr>";
                    form += "<tr>";
                    form += '<td colspan="2"><button class="btn btn-primary" value="' + data.id + '" onclick="UpdateCategory(this.value)">Save</button></td>';
                    form += '</tr>';
                    $('#categoryList').html(form);
                }
            })
        }

        function UpdateCategory(id) {
            var formData = '{';
            formData += '"categoryCode":"' + $('#category_code').val() + '",';
            formData += '"categoryName":"' + $('#category_name').val() + '",';
            formData += '"createdBy":"' + $('#createdBy').val() + '",'
            formData += '"createdOn":"' + $('#createdOn').val() + '"'
            formData += '}';

            $.ajax({
                url: '/api/category/' + id,
                type: 'put',
                contentType: 'application/json',
                data: formData,
                success: function(data) {
                    OpenList();
                }
            });
        }

        function formDelete(id) {
            $.ajax({
                url: '/api/category/' + id,
                type: 'get',
                contentType: 'application/json',
                success: function(data) {
                    var form = '<table class="table table-bordered">';
                    form += "<tr>";
                    form += "<td>Category Code</td>";
                    form += '<td><input class="form-control" type ="text" id="category_code" value="' + data.categoryCode + '" disabled></td>';
                    form += "</tr>";
                    form += "<tr>";
                    form += "<td>Category Name</td>";
                    form += '<td><input class="form-control" type="text" id="category_name" value="' + data.categoryName + '" disabled></td>';
                    form += '<td><input class="form-control" type="hidden" id="created_on" value="' + data.createdOn + '" ></td>';
                    form += '<td><input class="form-control" type="hidden" id="created_by" value="' + data.createdBy + '"></td>';
                    form += "</tr>";
                    form += "<tr>";
                    form += '<td colspan="2"><button class="btn btn-danger" value="' + data.id + '" onclick="DeleteCategory(this.value)">Delete</button></td>';
                    form += '</tr>';
                    $('#categoryList').html(form);
                }
            })
        }

        function DeleteCategory(id) {
            var formData = '{';
            formData += '"categoryCode":"' + $('#category_code').val() + '",';
            formData += '"categoryName":"' + $('#category_name').val() + '",';
            formData += '"createdBy":"' + $('#createdBy').val() + '",'
            formData += '"createdOn":"' + $('#createdOn').val() + '"'
            formData += '}';

            $.ajax({
                url: '/api/category/' + id,
                type: 'delete',
                contentType: 'application/json',
                data: formData,
                success: function(data) {
                    OpenList();
                }
            });
        }

        function SearchCategory(request) {
            //console.log(request)

            if (request.length > 0) {
                $.ajax({
                    url: '/api/searchcategory/' + request,
                    type: 'GET',
                    contentType: 'application/json',
                    success: function(result) {
                        //console.log(result)
                        let table = '<table class="table table-hover">';
                        table += "<tr> <th width='10%'>#</th> <th>Category Code</th> <th>Category Name</th> <th>Action</th> </tr>"
                        if (result.length > 0) {
                            for (let i = 0; i < result.length; i++) {
                                table += "<tr>";
                                table += "<td class='text-center'>" + (i + 1) + "</td>";
                                table += "<td>" + result[i].categoryCode + "</td>";
                                table += "<td>" + result[i].categoryName + "</td>";
                                table += "<td><button class='btn btn-primary' value='" + result[i].id + "' onclick='FormEdit(this.value)'>Edit</button> <button class='btn btn-danger' value='" + result[i].id + "' onclick='Delete(this.value)'>Delete</button> </td>";
                                table += "</tr>";
                            }
                        } else {
                            table += "<tr>";
                            table += "<td colspan='4' class='text-center'>No data</td>";
                            table += "</tr>";
                        }
                        table += "</table>";
                        $('#categoryList').html(table);
                    }
                });
            } else {
                OpenList(0, 5);
            }
        }
    </script>